Subject: bug#76028: 31; completing-read-multiple: Add prompt indicator

From: Juri Linkov <[email-masked]>
Date: Tue, 04 Feb 2025 09:54:17 +0200

>>   Describe face (face1,face2,...):
>>
>> A more generalized prompt would make this less clear, e.g.
>>
>>   Describe face (separator ‘,’):
>
> Giving an example does not solve the general issue of a uniform CRM
> indication for all `completing-read-multiple' calls. In the Emacs code
> base `completing-read-multiple' is not used widely but it is used in
> other packages, which we cannot update at once.

Wouldn't addition of more text to the prompt break these packages
in some way?  Maybe only those that rely on the fixed format
like minibuf-eldef.el that is quite rare.

> I find Stefan's suggestion of [comma-separated list] quite nice. See the
> patch I have sent in the other mail. Maybe we could use the
> [comma-separated list] indicator as fallback if a
> `completing-read-multiple' call does not provide examples on its own?

The only problem with the patch is that it would be better
to leave the existing format of the variable 'crm-separator'
to avoid possible backward-compatibility problems,
and then add a new variable or two for the separator
and its description.

> Another possibility might be to use the completion category and the
> separator string and convert that to an example, e.g., category face
> would yield the prompt "Describe face (face1,face2,...):".

Maybe then it's possible to provide the separator and its description
in the metadata?